summaryrefslogtreecommitdiff
path: root/postfix/postfix.sh
blob: a82d74687253a4309a8fe67ee3e174a2cd595dba (plain)
  1. #!/bin/sh
  2. #
  3. # /etc/local-COMMON/postfix/postfix.sh
  4. # Copyright 2002-2007 Jonas Smedegaard <dr@jones.dk>
  5. #
  6. # $Id: postfix.sh,v 1.76 2008-05-25 19:00:16 jonas Exp $
  7. #
  8. # Auto-tweak plain installed postfix Debian package
  9. #
  10. # TODO:
  11. # * Implement stuff from here: http://www.wsrcc.com/spam/
  12. # * Implement stuff from here: http://www.muine.org/~hoang/postfix.html
  13. # * Implement stuff from here: http://jimsun.linxnet.com/misc/postfix-anti-UCE.txt
  14. # * Figure out a way to use chroot jail for TLS stuff.
  15. # * Use https://www.dnswl.org/
  16. set -e
  17. # Let's standardize sort
  18. export LC_ALL=C
  19. warn() {
  20. echo >&2 "Warning: $1"
  21. }
  22. exit1() {
  23. echo >&2 "Error: $1"
  24. echo >&2 "Exiting..."
  25. exit 1
  26. }
  27. FORCE=${FORCE:-}
  28. REDPILL=${REDPILL:-REDPILL}
  29. REALM=${REALM:-ORG}
  30. TLS_CERT=${TLS_CERT:-/etc/ssl/certs/postfix.pem}
  31. TLS_KEY=${TLS_KEY:-/etc/ssl/private/postfix.pem}
  32. realmsdir="/etc/local-$REDPILL"
  33. thisrealm=$(cat "/etc/local-$REALM/realm" || dnsdomainname | tr '[:lower:]' '[:upper:]')
  34. confdir=/etc/postfix
  35. if ! [ -d "$realmsdir" ]; then
  36. warn "Realms directory \"$realmsdir\" does not exist."
  37. fi
  38. #postgrey=
  39. #if [ -x /usr/sbin/postgrey ]; then
  40. # # FIXME: Use this somehow, and only warn below
  41. # postgrey=1
  42. #else
  43. # exit1 "ERROR: Greylisting support (Debian package postgrey) missing."
  44. #fi
  45. dovecot=
  46. dovecot_lmtp=
  47. dovecot_deliver=
  48. if [ -x /usr/sbin/dovecot ]; then
  49. dovecot=1
  50. if [ -x /usr/lib/dovecot/lmtp ]; then
  51. dovecot_lmtp=1
  52. elif [ -x /usr/lib/dovecot/deliver ]; then
  53. warn "Dovecot LMTP missing - (Debian package dovecot-lmtp)."
  54. dovecot_deliver=1
  55. else
  56. warn "Dovecot deliver missing."
  57. fi
  58. else
  59. warn "Dovecot missing - (Debian package dovecot-core or dovecot)."
  60. fi
  61. tls_cert=
  62. if [ -f "$TLS_CERT" ] && [ -f "$TLS_KEY" ]; then
  63. tls_cert=1
  64. else
  65. warn "No TLS - requires certificate \"$TLS_CERT\" and key \"$TLS_KEY\"."
  66. fi
  67. # TODO: enable only on systems with user accounts
  68. submission=1
  69. # TODO: check that dovecot SASL is configured
  70. sasl_inbound=
  71. if [ -n "$tls_cert" ] && [ -n "$dovecot" ] && [ -n "$submission" ]; then
  72. sasl_inbound=1
  73. else
  74. warn "No inbound SASL authentication - requires TLS encryption and Dovecot."
  75. fi
  76. amavis=
  77. # TODO: maybe use AMaViS default of 20 (instead tuning spamassassin)
  78. # <https://www.ijs.si/software/amavisd/amavisd-new-docs.html#max_requests>
  79. default_amavis_maxproc=2
  80. if [ -x /usr/sbin/amavisd ] || [ -x /usr/sbin/amavisd-new ]; then
  81. amavis=1
  82. else
  83. warn "AMaViS missing (Debian package amavisd-new)."
  84. fi
  85. dkimproxy=
  86. #dkimproxy_maxproc_in=5
  87. # FIXME: update actual outgoing maxproc from /etc/default/dkimproxy (and /etc/dkimproxy/dkimproxy_out.conf too?)
  88. dkimproxy_maxproc_out=5
  89. if [ -x /usr/sbin/dkimproxy.in ]; then
  90. if [ "1" = "$amavis" ]; then
  91. dkimproxy=1
  92. else
  93. warn "No DKIM/Domainkey - requires DKIMproxy and AMaViS."
  94. fi
  95. else
  96. warn "DKIMproxy missing (Debian package dkimproxy)."
  97. fi
  98. catfilefromownrealm() {
  99. set -e
  100. file=$1
  101. [ -d "$realmsdir" ] || exit 0
  102. cat "$realmsdir/$thisrealm/$file"
  103. }
  104. catallfilesfromotherrealms() {
  105. set -e
  106. file=$1
  107. [ -d "$realmsdir" ] || exit 0
  108. [ -f "$realmsdir/realms" ] || exit 0
  109. realms=$(sed 's/#.*//' < "$realmsdir/realms")
  110. for realm in $realms; do
  111. if [ "$thisrealm" != "$realm" ]; then
  112. cat "$realmsdir/$realm/$file"
  113. fi
  114. done
  115. }
  116. catfirstfile() {
  117. set -e
  118. file=$1
  119. context=${2:-postfix}
  120. configdir=
  121. for dir in /etc/local "/etc/local-$REALM" "/etc/local-$REDPILL" /etc/local-COMMON; do
  122. if [ -d "$dir/$context" ] && [ -f "$dir/$context/$file" ]; then
  123. configdir="$dir/$context"
  124. break
  125. fi
  126. done
  127. if [ -z "$configdir" ]; then
  128. exit1 "ERROR: file \"$file\" not found."
  129. fi
  130. cat "$configdir/$file"
  131. }
  132. # TODO: support quoted string, and trailing comment.
  133. getperlvarfromfile() {
  134. set -e
  135. export var=$1
  136. export default=$2
  137. file=$3
  138. context=${4:-postfix}
  139. catfirstfile "$file" "$context" \
  140. | perl -nE'/^\$$ENV{"var"}\h*=\h*(\d+)/ and $s=$1; END {print length($s) ? $s : $ENV{"default"}}'
  141. }
  142. getlinesfromfile() {
  143. set -e
  144. param=$1
  145. shift
  146. replacements=
  147. for subparam in "$@"; do
  148. case "$subparam" in
  149. *=)
  150. oldparam=$(echo "$subparam" | awk -F= '{print $1}')
  151. replacements="$replacements;s/,*[^,]*$oldparam[^,]*,*/,/"
  152. continue
  153. ;;
  154. *=*=*)
  155. oldparam=$(echo "$subparam" | awk -F= '{print $1}')
  156. newparam=$(echo "$subparam" | awk -F= '{print $2}')
  157. newparamfile=$(echo "$subparam" | awk -F= '{print $3}')
  158. ;;
  159. *)
  160. oldparam=$subparam
  161. newparam=$subparam
  162. newparamfile=$subparam
  163. ;;
  164. esac
  165. newparamvalues=$(getlinesfromfile "$newparamfile" | sed -e 's/.*=[ ]*//' -e 's/,/ /g')
  166. newstring=
  167. for newparamvalue in $newparamvalues; do
  168. newstring="${newstring}$newparam $newparamvalue,"
  169. done
  170. replacements="$replacements;s/$oldparam/$newstring/"
  171. done
  172. echo -n "$param = "
  173. catfirstfile "$param" | sed 's/#.*//' | tr '\n' ',' | sed -e 's/^[, ]*//;s/[, ]\+/,/g' -e 's/\^/ /g' -e "s/,\$//$replacements"
  174. }
  175. _postconf() {
  176. postconf -c "$tempdir" "$1" "$(echo "$2" | tr '\n' ' ')"
  177. }
  178. postmapfiles=
  179. tempdir=$(mktemp -td postfix.XXXXXX)
  180. cp -a -t "$tempdir" "$confdir"/*
  181. # Inspired by D. J. Bernstein: http://cr.yp.to/smtp/greeting.html
  182. _postconf -e smtpd_banner="\$myhostname NO UCE ESMTP \$mail_name (Debian/GNU)"
  183. # Some badly configured setup use hostname instead of FQDN
  184. # Disable completely: Effective, but hurts executive type guys using windows servers... :-(
  185. #if _postconf myhostname | grep -q '\.'; then
  186. # _postconf -e smtpd_helo_required=yes
  187. #fi
  188. _postconf -e smtpd_helo_required=no
  189. _postconf -e "$(getlinesfromfile permit_mx_backup_networks)"
  190. _postconf -e maps_rbl_domains=
  191. _postconf -e "$(getlinesfromfile smtpd_client_restrictions reject_rhsbl_client)"
  192. _postconf -e "$(getlinesfromfile smtpd_helo_restrictions)"
  193. _postconf -e "$(getlinesfromfile smtpd_sender_restrictions reject_rhsbl_sender ${dkimproxy:-sender_access_regex=})"
  194. _postconf -e "$(getlinesfromfile smtpd_recipient_restrictions reject_maps_rbl=reject_rbl_client=maps_rbl_domains)"
  195. _postconf -e "$(getlinesfromfile smtpd_data_restrictions)"
  196. # FIXME: clear only specific line (not whole file) when dkimproxy unused
  197. if [ -f "$tempdir/sender_access_regex" ]; then
  198. if [ -n "$dkimproxy" ]; then
  199. grep -q -F '/^/ FILTER dkimsign:[127.0.0.1]:10026' "$tempdir/sender_access_regex" \
  200. || echo '/^/ FILTER dkimsign:[127.0.0.1]:10026' >> "$tempdir/sender_access_regex"
  201. else
  202. if grep -q -F '/^/ FILTER dkimsign:[127.0.0.1]:10026' "$tempdir/sender_access_regex"; then
  203. echo "echo '' > \"$confdir/sender_access_regex\"" >> "$tempdir/COMMANDS"
  204. rm "$tempdir/sender_access_regex"
  205. fi
  206. fi
  207. postmapfiles="$postmapfiles sender_access_regex"
  208. fi
  209. # Support exceptions to default response
  210. # (Day Old Bread (dob) lists need to reject only temporarily)
  211. _postconf -e rbl_reply_maps="hash:$confdir/rbl_reply_map"
  212. sed 's/#.*//' \
  213. < /etc/local-COMMON/postfix/rbl_reply_map \
  214. > "$tempdir/rbl_reply_map"
  215. postmapfiles="$postmapfiles rbl_reply_map"
  216. # Verify senders of common suspicious and known verifiable domains
  217. # (exclude verification of postmaster@ to not verify verification probes)
  218. # (add own domains before peers for (rare) cases of duplicates)
  219. # FIXME: somehow do this step only if enabled in smtpd_sender_restrictions
  220. # TODO: Properly implement exception exclusion like yahoo (which does not want to be checked any longer!)
  221. grep -v yahoo \
  222. < /etc/local-COMMON/postfix/maildomains \
  223. | sort \
  224. | sed 's/$/ reject_unverified_sender/' \
  225. > "$tempdir/sender_access"
  226. ( catfilefromownrealm maildomains | sort; catallfilesfromotherrealms maildomains | sort ) \
  227. | sed 's/\(.*\)$/postmaster@\1 permit\n\1 reject_unverified_sender/' \
  228. >> "$tempdir/sender_access"
  229. [ ! -f "$tempdir/sender_access.addon" ] || cat "$tempdir/sender_access.addon" \
  230. >> "$tempdir/sender_access"
  231. postmapfiles="$postmapfiles sender_access"
  232. _postconf -e unverified_sender_reject_code=550
  233. # Trust recipient verification too
  234. _postconf -e unverified_recipient_reject_code=550
  235. if [ -n "$dovecot_lmtp" ]; then
  236. _postconf -e mailbox_transport=lmtp:unix:private/dovecot-lmtp
  237. _postconf -X mailbox_command
  238. elif [ -n "$dovecot_deliver" ]; then
  239. _postconf -X mailbox_transport
  240. _postconf -e mailbox_command=/usr/lib/dovecot/deliver
  241. else
  242. _postconf -X mailbox_transport
  243. _postconf -X mailbox_command
  244. fi
  245. # outbound opportunistic encryption
  246. _postconf -e smtp_tls_security_level=may
  247. if [ -n "$tls_cert" ]; then
  248. _postconf -e smtp_tls_cert_file="$TLS_CERT"
  249. _postconf -e smtp_tls_key_file="$TLS_KEY"
  250. else
  251. _postconf -X smtp_tls_cert_file
  252. _postconf -X smtp_tls_key_file
  253. fi
  254. _postconf -e smtp_tls_loglevel=1
  255. # enforce TLS trust path towards peers
  256. catallfilesfromotherrealms mailhost | sort \
  257. | sed 's/^/[/;s/$/]:submission secure/' \
  258. > "$tempdir/tls_policy"
  259. [ ! -f "$tempdir/tls_policy.addon" ] || cat "$tempdir/tls_policy.addon" \
  260. >> "$tempdir/tls_policy"
  261. postmapfiles="$postmapfiles tls_policy"
  262. _postconf -e smtp_tls_policy_maps="hash:$confdir/tls_policy"
  263. # inbound opportunistic encryption
  264. if [ -n "$tls_cert" ]; then
  265. _postconf -e smtpd_tls_security_level=may
  266. _postconf -e smtpd_tls_cert_file="$TLS_CERT"
  267. _postconf -e smtpd_tls_key_file="$TLS_KEY"
  268. _postconf -e smtpd_tls_loglevel=1
  269. _postconf -e smtpd_tls_auth_only=yes
  270. _postconf -e smtpd_tls_received_header=yes
  271. else
  272. _postconf -e smtpd_tls_security_level=none
  273. _postconf -X smtpd_tls_cert_file
  274. _postconf -X smtpd_tls_key_file
  275. _postconf -X smtpd_tls_loglevel
  276. _postconf -X smtpd_tls_auth_only
  277. _postconf -X smtpd_tls_received_header
  278. fi
  279. # Avoid smtpd_tls_CApath or smtpd_tls_CAfile to trick outlook.com
  280. # See <http://postfix.1071664.n5.nabble.com/Problems-with-incoming-mails-from-outlook-com-td78356.html>
  281. _postconf -X smtpd_tls_CApath
  282. _postconf -X smtpd_tls_CAfile
  283. # obsolete TLS-related settings
  284. _postconf -X smtpd_use_tls
  285. _postconf -X smtp_tls_CApath
  286. _postconf -X lmtp_tls_CApath
  287. _postconf -X smtp_tls_CAfile
  288. _postconf -X lmtp_tls_CAfile
  289. _postconf -X smtpd_tls_ask_ccert
  290. _postconf -X smtp_tls_note_starttls_offer
  291. _postconf -X smtpd_tls_session_cache_database
  292. _postconf -X smtpd_tls_session_cache_timeout
  293. _postconf -X smtp_tls_session_cache_database
  294. _postconf -X tls_random_exchange_name
  295. _postconf -X tls_random_source
  296. # submission
  297. # <http://www.postfix.org/SASL_README.html>
  298. # <https://doc.dovecot.org/configuration_manual/howto/postfix_and_dovecot_sasl/#using-sasl-with-postfix-submission-port>
  299. if [ -n "$submission" ]; then
  300. _postconf -Me submission/inet="
  301. submission inet n - y - - smtpd
  302. -o syslog_name=postfix/\$service_name
  303. -o smtpd_tls_security_level=encrypt
  304. "
  305. _postconf -Me smtps/inet="
  306. smtps inet n - y - - smtpd
  307. -o syslog_name=postfix/\$service_name
  308. -o smtpd_tls_wrappermode=yes
  309. -o smtpd_sasl_auth_enable=yes
  310. "
  311. if [ -n "$sasl_inbound" ]; then
  312. _postconf -Pe submission/inet/smtpd_sasl_auth_enable=yes
  313. _postconf -Pe smtps/inet/smtpd_sasl_auth_enable=yes
  314. else
  315. _postconf -PX submission/inet/smtpd_sasl_auth_enable
  316. _postconf -PX smtps/inet/smtpd_sasl_auth_enable
  317. fi
  318. else
  319. _postconf -MX submission/inet
  320. _postconf -MX smtps/inet
  321. fi
  322. if [ -n "$sasl_inbound" ]; then
  323. _postconf -e smtpd_sasl_local_domain=\$mydomain
  324. _postconf -e smtpd_sasl_type=dovecot
  325. _postconf -e smtpd_sasl_path=private/auth
  326. _postconf -e broken_sasl_auth_clients=yes
  327. else
  328. _postconf -X smtpd_sasl_local_domain
  329. _postconf -X smtpd_sasl_type
  330. _postconf -X smtpd_sasl_path
  331. _postconf -X broken_sasl_auth_clients
  332. fi
  333. # obsolete SASL-related settings
  334. _postconf -X smtpd_sasl_auth_enable
  335. _postconf -X smtpd_sasl_security_options
  336. if [ -n "$amavis" ]; then
  337. amavis_maxproc=$(getperlvarfromfile max_servers "$default_amavis_maxproc" amavisd.conf.addon amavis)
  338. _postconf -Me amavisfeed/unix="
  339. amavisfeed unix - - n - $amavis_maxproc lmtp
  340. -o lmtp_data_done_timeout=1200s
  341. -o lmtp_send_xforward_command=yes
  342. -o disable_dns_lookups=yes
  343. -o max_use=$amavis_maxproc
  344. "
  345. _postconf -Me 127.0.0.1:10025/inet='
  346. 127.0.0.1:10025 inet n - n - - smtpd
  347. -o content_filter=
  348. -o local_recipient_maps=
  349. -o relay_recipient_maps=
  350. -o smtpd_restriction_classes=
  351. -o smtpd_delay_reject=no
  352. -o smtpd_client_restrictions=permit_mynetworks,reject
  353. -o smtpd_helo_restrictions=
  354. -o smtpd_sender_restrictions=
  355. -o smtpd_recipient_restrictions=permit_mynetworks,reject
  356. -o smtpd_data_restrictions=reject_unauth_pipelining
  357. -o smtpd_end_of_data_restrictions=
  358. -o mynetworks=127.0.0.0/8
  359. -o smtpd_error_sleep_time=0
  360. -o smtpd_soft_error_limit=1001
  361. -o smtpd_hard_error_limit=1000
  362. -o smtpd_client_connection_count_limit=0
  363. -o smtpd_client_connection_rate_limit=0
  364. -o receive_override_options=no_unknown_recipient_checks,no_header_body_checks,no_milters
  365. '
  366. _postconf -e receive_override_options=no_address_mappings
  367. if [ -n "$dkimproxy" ]; then
  368. _postconf -e content_filter='amavisfeed:[127.0.0.1]:10028'
  369. _postconf -Pe pickup/fifo/content_filter='dkimsign:127.0.0.1:10028'
  370. if [ -n "$submission" ]; then
  371. _postconf -Pe submission/inet/content_filter='dkimsign:[127.0.0.1]:10028'
  372. _postconf -Pe smtps/inet/content_filter='dkimsign:[127.0.0.1]:10028'
  373. fi
  374. _postconf -Me dkimsign/unix="
  375. dkimsign unix - - n - $dkimproxy_maxproc_out smtp
  376. -o smtp_send_xforward_command=yes
  377. -o smtp_discard_ehlo_keywords=8bitmime,starttls
  378. "
  379. _postconf -Me 127.0.0.1:10029/inet='
  380. 127.0.0.1:10029 inet n - n - - smtpd
  381. -o content_filter=
  382. -o receive_override_options=no_unknown_recipient_checks,no_header_body_checks,no_milters
  383. -o smtpd_helo_restrictions=
  384. -o smtpd_client_restrictions=
  385. -o smtpd_sender_restrictions=
  386. -o smtpd_recipient_restrictions=permit_mynetworks,reject
  387. -o mynetworks=127.0.0.0/8
  388. -o smtpd_authorized_xforward_hosts=127.0.0.0/8
  389. '
  390. else
  391. _postconf -MX dkimsign/unix
  392. _postconf -MX 127.0.0.1:10029/inet
  393. _postconf -e content_filter='amavisfeed:[127.0.0.1]:10024'
  394. _postconf -PX pickup/fifo/content_filter
  395. if [ -n "$submission" ]; then
  396. _postconf -PX submission/inet/content_filter
  397. _postconf -PX smtps/inet/content_filter
  398. fi
  399. fi
  400. else
  401. _postconf -MX amavisfeed/unix
  402. _postconf -MX 127.0.0.1:10025/inet
  403. _postconf -X content_filter
  404. _postconf -X receive_override_options
  405. fi
  406. # obsolete settings
  407. _postconf -X max_use
  408. _postconf -MX smtp-amavis/unix
  409. diff -ruNw "$confdir" "$tempdir" || if [ $? -gt 1 ]; then exit $?; else needs_reload=1; fi
  410. if [ "1" = "$FORCE" ]; then
  411. do_update=y
  412. elif [ "1" = "$needs_reload" ]; then
  413. echo -n "Above is the intended changes. OK to update (y/N)? "
  414. read do_update
  415. fi
  416. case $do_update in
  417. y|Y)
  418. if [ -f "$tempdir/COMMANDS" ]; then
  419. sh -s < "$tempdir/COMMANDS"
  420. fi
  421. rm -f "$tempdir/COMMANDS"
  422. diff -q "$confdir/master.cf" "$tempdir/master.cf" || if [ $? -gt 1 ]; then exit $?; else needs_restart=1; fi
  423. cp -a -f -t "$confdir" "$tempdir"/*
  424. rm -rf "$tempdir"
  425. for file in $postmapfiles; do
  426. postmap "$confdir/$file"
  427. done
  428. if [ "1" = "$needs_restart" ]; then
  429. service postfix restart
  430. else
  431. service postfix force-reload
  432. fi
  433. if [ "1" = "$needs_reload" ]; then
  434. echo >&2 "Changes applied!"
  435. fi
  436. ;;
  437. *)
  438. if [ "1" = "$needs_reload" ]; then
  439. exit1 "Aborted!"
  440. fi
  441. ;;
  442. esac
  443. if [ "1" != "$needs_reload" ]; then
  444. echo >&2 "No changes needed!"
  445. fi
  446. # Based on this: http://jimsun.linxnet.com/misc/postfix-anti-UCE.txt
  447. # Support for trusted MX backup networks added
  448. # PCRE stuff avoided, as PCRE is only optional on newest Debian packages
  449. # RBLs replaced with those recommended by http://www.antispews.org/
  450. # spam filter based on these: http://www.postfix.org/FILTER_README.html
  451. # https://www.ijs.si/software/amavisd/amavisd-new-docs.html
  452. # TLS based on this: http://www.postfix.org/TLS_README.html
  453. # Here's a convenient overview of different blackholes:
  454. # http://rbls.org/